
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>iOS 时间校准解决方案 / 憋错料</title>

    <meta name="description" content="iOS 时间校准解决方案 背景 在 iOS 开发中,凡是用到系统时间的,都要考虑一个问题:对时.有些业务是无需对时,或可以以用户时间为准的,比如动画用到的时间.一些日程类应用等.但电商相关的业务大都不能直接使用设备上的时间,而是需要跟服务器校准后的时间,例如: 区间判断:一些优惠促销活动需要在 app 端判断当前是否在活动期间内.如果用户设备时间不准,会给用户错误的信息,导致投诉. 倒计时:各种秒杀.限时促销.未支付订单的失效等的倒计时.如果用户设备时间不准,会带来倒计时结束后刷新页面,状态没变化的问题.可以测试一下电商">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">iOS 时间校准解决方案</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1>背景</h1>
<p>在 iOS 开发中，凡是用到系统时间的，都要考虑一个问题：对时。有些业务是无需对时，或可以以用户时间为准的，比如动画用到的时间、一些日程类应用等。但电商相关的业务大都不能直接使用设备上的时间，而是需要跟服务器校准后的时间，例如：</p>
<ul>
<li>区间判断：一些优惠促销活动需要在 app 端判断当前是否在活动期间内。如果用户设备时间不准，会给用户错误的信息，导致投诉。</li>
<li>倒计时：各种秒杀、限时促销、未支付订单的失效等的倒计时。如果用户设备时间不准，会带来倒计时结束后刷新页面，状态没变化的问题。可以测试一下电商大厂的 app，任意拨表之后倒计时仍是正确的。</li>
<li>同步：如有数据同步的需求，设备时间不准会造成不能正确判断数据的新旧关系，可能会让旧数据覆盖新数据，造成数据丢失。</li>
<li>请求时间戳：对于分页的数据，为了防止新插入的数据导致翻页时数据错乱，一个常见的解决方案是请求列表时加上时间戳的参数，后台过滤只显示时间戳之后的数据。如果用户设备表慢了，就会显示不出最新的数据，导致新发布内容在列表不出现的情况。</li>
</ul>
<p>可以看出，对时这个需求是非常普遍的。不过实现起来并不难，在这里分享一下我们的经验。</p>
<h1>解决方案</h1>
<p>之所以叫解决方案，是因为这个功能不单是 app 端加几行代码，而是前后端配合完成的。大概思路如下：</p>
<ol>
<li>后端需要做的：每一个网络请求的返回数据都要带有服务器当前时间戳</li>
<li>app 端的网络框架在网络请求的公共回调处取出时间戳</li>
<li>将服务器时间与本地时间的差值缓存到本地</li>
<li>需要使用时间时，使用本地时间和缓存的时间差，算出相应的服务器时间</li>
</ol>
<h3>网络请求回调</h3>
<p>服务器的时间戳可以加在 response body 里作为公共字段。在我的项目里，因为有少量 get 请求，所以放在了 response header 里。代码类似如下：</p>
<pre><code>+ (void)handleSuccessResponse:(id)responseObject operation:(AFHTTPRequestOperation *)operation responseType:(Class)responseClass success:(void (^)(id))successBlock failure:(void (^)(NSError *))failureBlock {
    long long timestamp = [[operation.response.allHeaderFields objectForKey:@"Response-Timestamp"] longLongValue];
    [HAMDateTimeUtils updateServerTime:timestamp];
}</code></pre>
<p>每次网络请求成功时更新时间差的缓存。</p>
<p>一个小的注意点是，处理 timestamp 最好始终用 long long 类型。因为 timestamp 传统上是以毫秒为单位的（虽然在 iOS 这个奇葩系统里 NSTimeInteval 是以秒为单位），在 32 位系统上 long 和 NSInteger 都存不下，会溢出。当然，现在 32 位系统的设备已经不常见了。</p>
<h3>时间差的缓存</h3>
<p>在更新缓存时，把服务器时间与本地当前的时间差保存在单例里。</p>
<h6>HAMDateTimeUtils.m</h6>
<pre><code>- (void)updateServerTime:(long long)timestamp {
    NSTimeInterval timeInteval = timestamp / 1000.0 - [[NSDate date] timeIntervalSince1970];
    [self sharedInstance].timeIntevalDifference = timeInteval;
}</code></pre>
<h3>提供校准过的时间</h3>
<p>需要使用时间时，根据当前时间和缓存过的时间差，计算校准后的时间：</p>
<h6>HAMDateTimeUtils.m</h6>
<pre><code>+ (NSDate*)currentTime {
    NSDate* serverDate = [NSDate dateWithTimeIntervalSinceNow:[self sharedInstance].timeIntevalDifference];
    return serverDate;
}

// 以毫秒为单位
+ (long long)currentTimeStamp {
    NSTimeInterval localTime = [[NSDate date] timeIntervalSince1970];
    NSTimeInterval timeDifference = [WNYDateTimeUtils sharedInstance].timeIntevalDifference;

    return (long long)((localTimeStamp + timeDifference) * 1000);
}</code></pre>
<p>使用时只需调用&nbsp;<code>[HAMDateTimeUtils currentTime]</code>&nbsp;或&nbsp;<code>[HAMDateTimeUtils currentTimeStamp]</code>&nbsp;即可。</p>
<h1>讨论</h1>
<ul>
<li>Q：这样得出的时间准确吗？<br />A：会有一定误差。原因在于，服务器返回的时间戳是从服务器开始返回数据的时间，到客户端接收时会有一点延迟。不过对于我们的后台，这个延迟一般 &lt;100 ms，对于我们的业务来说没什么影响。<br />如果对准确性要求更高，可以考虑使用专门的对时接口，不知道国家天文台有没有……<br />另外，这种对时的方案只是用于优化 UI 层面的显示，不能防止用户恶意的篡改。要始终记住客户端的时间戳是不可信的，后端业务凡是使用时间都务必用服务器的时间。</li>
<li>Q：缓存的时候，为什么只存在单例里，不持久化存储？<br />A：这个我也考虑过，主要是觉得再次启动的时候，时间差可能会发生变化，感觉持久化没有太大的必要。如果觉得有必要的话，也可以在 userDefault 里存一份，启动时取出来即可。</li>
</ul>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-15 04:52:30 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/alt/" title="alt">alt</a>, <a href="https://www.biecuoliao.com/tag/and/" title="and">and</a>, <a href="https://www.biecuoliao.com/tag/value/" title="value">value</a>, <a href="https://www.biecuoliao.com/tag/%e7%b1%bb%e5%9e%8b/" title="类型">类型</a>, <a href="https://www.biecuoliao.com/tag/%e6%98%be%e7%a4%ba/" title="显示">显示</a>, <a href="https://www.biecuoliao.com/tag/request/" title="request">request</a>, <a href="https://www.biecuoliao.com/tag/%e5%a4%b1%e6%95%88/" title="失效">失效</a>, <a href="https://www.biecuoliao.com/tag/efault/" title="efault">efault</a>, <a href="https://www.biecuoliao.com/tag/local/" title="local">local</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>iOS 时间校准解决方案的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0k9EYb4.html" rel="bookmark">Quartz定时任务和IIS程序池闲置超时时间冲突解决方案</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.问题描述 Bs项目中用Quartz功能执行一个定时任务(每隔5分钟执行一个Job),正常情况,Quartz定时任务会5分钟执行一次,但IIS程序池闲置 超时默认为20分钟,造成的结果是:定时任务只执行了4次.那么怎么解决程序池闲置超时引进Quartz定时任务停止执行问题? 二.解决方案方案一:设置IIS默认闲置超时为1740(跟程序池默认回收时间1740)方案二:IIS服务器规定的时间内,定时向服务器取一次数据 三.方案介绍1)方案一:设置IIS默认闲置超时为1740(跟程序池默认回收时间1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzXqpO3.html" rel="bookmark">iOS时间问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS时间问题 在iOS开发中,经常会遇到各种各样的时间问题,8小时时差,时间戳,求时间间隔,农历等等.解决办法网上比比皆是,但大多零零散散,很多资料并没有说明其中问题.这里集中总结一下,以便于以后查阅和供大家参考.有我自己的理解,错漏之处请大家吐槽. NSDate的8小时问题 NSDate转字符串时间 初始化一个NSDate时间[NSDate date],获取的是零时区的时间(格林尼治的时间: 年-月-日 时:分:秒: +时区),而北京时间是东八区时间,因为时区不同,所以打印的时间相差了8小时			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rxBb1M.html" rel="bookmark">iOS时间格式化的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				**iOS时间格式化方法** //时间转换方法 //    long nowT = time(NULL);  获取当前时间 - (NSString *)revertTimeFormat:(long)timesp{     NSDate *data = [NSDate dateWithTimeIntervalSince1970:timesp];//获得data          NSDateFormatter* formatter = [[NSDateFormatter alloc] init];			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rKPq14.html" rel="bookmark">支持WEB、Android、IOS的地图解决方案</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自原文 支持WEB.Android.IOS的地图解决方案 工具链 GIS工具集 OpenGeo Suite 包含PostGIS, GeoServer, GeoWebCache, OpenLayers, 和 QGIS 地图准备 QGIS 导入.导出.编辑.shp,postgis,geotiff,geojson,dxf等多种GIS文件,给普通图片配准到地理坐标 教程:http://www.qgistutorials.com/en/ DraftSight 编辑CAD文件 SketchUp   从CA			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/ME1RrXM.html" rel="bookmark">iOS 时间处理（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				NSDate NSDate对象用来表示一个具体的时间点. NSDate是一个类簇,我们所使用的NSDate对象,都是NSDate的私有子类的实体. NSDate存储的是GMT时间,使用的时候会根据 当前应用 指定的 时区 进行时间上的增减,以供计算或显示. 可以快速地获取的时间点有: now (当前时间点) 相对于1 January 2001, GMT的时间点 相对于1970的时间点 distantFuture (不可达到的未来的某个时间点) distantPast (不可达到的过去的某个时间点			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3O7ddG3.html" rel="bookmark">iOS &amp;quot&semi;Xcode process launch failed&colon; Security&amp;quot&semi; in iPhone 6， iOS 8 －解决方案</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题重述: 在iOS 8中第一次运行App,Xcode出现弹出框:&quot;Xcode process launch failed: Security&quot; 解决方案: &quot;If you get this, the app has installed on your device. You have to tap the icon. It will ask you if you really want to run it. Say &quot;yes&quot; and then Buil			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPDXyPM.html" rel="bookmark">iOS时间格式的转换</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在开发iOS程序时,有时候需要将时间格式调整成自己希望的格式,这个时候我们可以用NSDateFormatter类来处理. 例如: //实例化一个NSDateFormatter对象 NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init]; //设定时间格式,这里可以设置成自己需要的格式 [dateFormatter setDateFormat:@&quot;yyyy-MM-dd HH:mm:ss&quot;]; //用[NSDate d			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47Xgl6M.html" rel="bookmark">iOS 时间的处理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				做App避免不了要和时间打交道,关于时间的处理,里面有不少门道,远不是一行API调用,获取当前系统时间这么简单.我们需要了解与时间相关的各种API之间的差别,再因场景而异去设计相应的机制. 时间的形式 在开始深入讨论之前,我们需要确信一个前提:时间是线性的.即任意一个时刻,这个地球上只有一个绝对时间值存在,只不过因为时区或者文化的差异,处于同一时空的我们对同一时间的表述或者理解不同.这个看似简单明了的道理,是我们理解各种与时间相关的复杂概念的基石.就像UTF-8和UTF-16其实都是Unicod			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0n7qxx3.html" rel="bookmark">iOS时间轴的实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近项目需求,恰好要做一个时间轴,而iOS这方面时间轴的例子也比较少,我就把自己所做的例子和思路共享出来给大家,共同学习. 时间轴的具体实现效果如图1所示:  图1 第一步:看到这个图,我们想到的第一反应就是使用tableView或者CollectionView来完成,那么我这里使用的是tableView.首先,创建一个Single View Application项目,在Main.Storyboard里面拖入一个TableView(如图2所示),这里别忘记了把TableView的delegat			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/bMoNYB4.html" rel="bookmark" class="title">windows下使用putty&plus;psftp连接linux虚拟机进行文件传输</a>
					<div>
						嘛,首先需要用putty连接linux.除了重要的ssh协议的配置之外,还可能要在linux下输入命令: service iptables stop(用于关闭防火墙) service sshd sta ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/k0elO5M.html" rel="bookmark" class="title">&lbrack;转&rsqb;如何编写和应用Java的自定义异常类</a>
					<div>
						编写自定义异常类实际上是继承一个API标准异常类,用新定义的异常处理信息覆盖原有信息的过程.常用的编写自定义异常类的模式如下: public class CustomException extends ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmGPg13.html" rel="bookmark" class="title">【VC&plus;&plus;学习笔记四】MFC应用程序中框架类的获取</a>
					<div>
						一.文档类中 获取视图: 先获取主窗体,在根据主窗体获取视图 pMain-&gt;GetActiveDocument();注意类型转换 由于文档中可能包含多个视图,可以按照下面函数获取: CView* ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBAPKZ4.html" rel="bookmark" class="title">Google MapReduce&sol;GFS&sol;BigTable三大技术的论文中译版</a>
					<div>
						今天查找分布式计算的有关资料,发现Google的三大核心技术MapReduce.GFS和BigTable的论文都已经被翻译成高质量的中文,更巧的是,这三篇中译版的原发地都是CSDN的Blog.其中最新 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eneOp3.html" rel="bookmark" class="title">漠视规则，人生处处是&OpenCurlyDoubleQuote;老虎&rdquo;e</a>
					<div>
						http://www.huishoushang.com/1107468/http://www.huishoushang.com/1107469/http://www.huishoushang.com/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0x5YL73.html" rel="bookmark" class="title">socket  bind函数</a>
					<div>
						1 #include&lt;stdio.h&gt; 2 #include&lt;sys/types.h&gt; 3 #include&lt;sys/socket.h&gt; 4 #include&lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/415qzX4.html" rel="bookmark" class="title">Ubuntu 14&period;10 下Hive配置</a>
					<div>
						1 系统环境 Ubuntu 14.10 JDK-7 Hadoop 2.6.0 2 安装步骤 2.1 下载Hive 我第一次安装的时候,下载的是Hive-1.2.1,配置好之后,总是报错 [ERROR] ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPD7VvM.html" rel="bookmark" class="title">易宝典文章&mdash;&mdash;玩转Office 365中的Exchange Online服务 之三 了解Office 365管理中心</a>
					<div>
						继续前面的话题,现在已经有了Office 365的环境.可以很轻松的向甲方客户或公司老板进行展示了.但是在展示之前,首先要自己先对Office 365进行深入的了解和试用,否则在Q&amp;A环节会被 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEvxyP0.html" rel="bookmark" class="title">关于JSP页面中根据checked的值显示隐藏行的问题</a>
					<div>
						这是一个查询页面,在我的JSP页面中有一个单选框,C标签根据从数据库中获取到的值选择checked=“checked”与否: 当单机单选框时会调用一个showme()方法,选中则显示隐藏的两行,未选中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bqDJoM.html" rel="bookmark" class="title">JVM类加载器ClassLoader解读</a>
					<div>
						ClassLoader类加载器负责将类加载进入JVM中. ClassLoader的作用 (1)加载class文件进入JVM (2)审查每个类应该由谁加载,采用双亲委托机制 (3)将class字节码重新 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pPVOJ4.html" rel="bookmark" class="title">最全面的AndroidStudio配置指南总结-包括护眼模式</a>
					<div>
						使用AndroidStudio开发APP已有半年多的时间了,从刚开始的不习惯到慢慢适应再到逐渐喜欢上AndroidStudio,中间的过程颇有一番曲折,现在把自己对AndroidStudio的配置心得 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OZjZP0.html" rel="bookmark" class="title">js解析json字符串数组</a>
					<div>
						json解析字符串数据 例如如下: var array= [ {}, {}, { [ {}, {}, {}, ] } ] 解析json数组 一般是$.each(array,function(i,val ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyQyQVM.html" rel="bookmark" class="title">bridged&comma;host-only&comma;nat</a>
					<div>
						bridged(桥接模式) 一种网络连接模式,也是VMware的一种工作模式. bridge   就是&quot;桥&quot;的意思,说起桥接,就不能不说局域网.比如我们有两个局域网络,他们的ip段 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVqJNk4.html" rel="bookmark" class="title">node&period;js的npm使用方法</a>
					<div>
						1.npm init 初始化 package.json 2.npm install 下载依赖 npm install mysql 通过 npm 下载依赖包: 3.npm install 依赖 --sa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bRw790.html" rel="bookmark" class="title">SpringMVC的初始</a>
					<div>
						1:其实一开始对SSH和SSM并不是很熟悉的,对SSH可能熟悉些(Struts,Spring,Hibernate)这三个框架.但是由于框架的更新,和出现了更好的框架,一些老框架就被淘汰了,但是呢,一些 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPeygm0.html" rel="bookmark" class="title">【BZOJ4551】&lbrack;Tjoi2016&amp;amp&semi;Heoi2016&rsqb;树 并查集</a>
					<div>
						[BZOJ4551][Tjoi2016&amp;Heoi2016]树 Description 在2016年,佳媛姐姐刚刚学习了树,非常开心.现在他想解决这样一个问题:给定一颗有根树(根为1),有以下  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pkxEo3.html" rel="bookmark" class="title">太监发情了怎么办&quest;</a>
					<div>
						江湖上一直传闻那个安公公.安德海怎样怎样,我就纳闷了,不是一个公公太监嘛,它能够怎样怎样吗? 网上那么一查丫,其实太监也是有需求的,什么需求呢,就是发情的需求,欲的需求. 控制男性发情的性激素是由睾丸 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l9eRZ3.html" rel="bookmark" class="title">15、导航滑动动画</a>
					<div>
						在触屏设备上,手指滑动页面,或者单击导航选项时,增加导航下横线滑动的效果: 这个版本有点简单粗暴,同事在项目中优化了一下算法.这里只是简单记录一下大致思路: 1.导航使用 ListView 控件,下面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ran110.html" rel="bookmark" class="title">SWIFT推送之本地推送&lpar;UILocalNotification&rpar;之二带按钮的消息</a>
					<div>
						上一篇讲到的本地推送是普通的消息推送,本篇要讲一下带按钮动作的推送消息,先上个图瞅瞅: 继上一篇的内容进行小小的改动: 在didFinishLaunchingWithOptions方法内进行以下修改  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YWBbr4.html" rel="bookmark" class="title">D3DXCreateTextureFromFile</a>
					<div>
						HRESULT D3DXCreateTextureFromFile( __in LPDIRECT3DDEVICE9 pDevice, __in LPCTSTR pSrcFile, __out LPDI ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
